/*
 * s_turtle.h
 */

#ifndef __LINUX__
#include <windows.h>
#endif

/*
 *
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <stdlib.h>

/*
 *
 */

#define S_TURTLE_PROGRAM_SIZE 10000

static char S_turlt_program [ S_TURTLE_PROGRAM_SIZE ];
static int S_turtle_program_end = 0;

/*
 *
 */

#define	S_TURTLE_MOVE	'm'
#define	S_TURTLE_JUMP	'j'
#define	S_TURTLE_TURN	't'

/*
 *
 */

static void S_turtle_add_program ( char code ) {

  if ( S_turtle_program_end < S_TURTLE_PROGRAM_SIZE ) {
	S_turlt_program [ S_turtle_program_end++ ] = code;
  } else {
	fprintf ( stderr, "Too many codes\n" );
  }
}

/*
 *
 */

#define S_TURTLE_SCALE	100
#define S_TURLTE_CENTER  (S_TURTLE_SCALE/2)

static int run_flag = 0;


static void S_turtle_display() {

  static int dx[] = {  0,  1,  1,  1,  0, -1, -1, -1 };
  static int dy[] = {  1,  1,  0, -1, -1, -1,  0,  1 };

  int px = 0;
  int py = 0;
  int dr = 0;
  int pc;

  glClear(GL_COLOR_BUFFER_BIT);

  glBegin(GL_POINTS);
  for ( pc = 0; pc < S_turtle_program_end; pc++ ) {
	switch ( S_turlt_program [ pc ] ) {
	case S_TURTLE_MOVE:
	  glVertex2d((double)px/S_TURTLE_SCALE, (double)py/S_TURTLE_SCALE);
	case S_TURTLE_JUMP:
	  px += dx[dr];
	  py += dy[dr];
	  break;
	case S_TURTLE_TURN:
	  dr = ( dr + 1 ) % 8;
	  break;
	}
  }
  glEnd();

  glFlush();
}

void S_turtle_graphics_init(void)
{
  glClearColor(0.0, 0.0, 1.0, 1.0);
}

static void S_turlte_atexit() {
  char *argv[] = { "Turtle", NULL };
  int argc = 1;

	if ( run_flag > 0 ) {
		_exit ( 0 );
	}
	run_flag = 1;


  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(S_turtle_display);
  S_turtle_graphics_init();
  glutMainLoop();

	_exit(0);
}

/*
 *
 */

extern void s_turtle_move( void );
extern void s_turtle_jump( void );
extern void s_turtle_turn( void );

/*
 *
 */

static S_turtle_init_flag = 0;

static void S_turtle_init(void) {

  if ( S_turtle_init_flag == 0 ) {
	S_turtle_init_flag = 1;
	atexit ( S_turlte_atexit );
  }
}

/*
 *
 */

void s_turtle_move() {
  S_turtle_init();
  S_turtle_add_program ( S_TURTLE_MOVE );
}

void s_turtle_jump() {
  S_turtle_init();
  S_turtle_add_program ( S_TURTLE_JUMP );
}

void s_turtle_turn() {
  S_turtle_init();
  S_turtle_add_program ( S_TURTLE_TURN );
}

/*
 *
 */
